/* Linked List */

#include <iostream>
#include <memory>

using namespace std;

class Nodey {
	public:

      int info;
      shared_ptr<Nodey> next;

      Nodey(int);
};


class Listy {
	shared_ptr<Nodey> head;
    
    public:

    void push(int);
    void addAtEnd(int);
    void printList();
};

Nodey::Nodey(int num){
   info = num;
}

void Listy::push(int num){
	shared_ptr<Nodey> tmp = make_shared<Nodey>(num);
	tmp->next = head;
	head = tmp;
}

void Listy::addAtEnd(int num){
	shared_ptr<Nodey> tmp = make_shared<Nodey>(num);
	if (head == NULL){
		head = tmp;
	}
	shared_ptr<Nodey> current = head;
	while(current->next != NULL){ 
		current = current->next;
	}
	current->next = tmp;

}

void Listy::printList(){
	shared_ptr<Nodey> nextPtr = head;
	while (nextPtr != NULL){
		cout << nextPtr->info << endl;
		nextPtr = nextPtr->next;
	}
}


int main(){
	shared_ptr<Listy> myList = make_shared<Listy>();
    myList->push(100);
    myList->push(90);
    myList->push(70);
    myList->push(50);
    myList->push(40);
    myList->push(30);
    myList->push(10);
    myList->push(8);
    myList->push(5);
    myList->push(2);
    myList->printList();
    
    cout << "\n\n\n\n";
    shared_ptr<Listy> myList2 = make_shared<Listy>();
    myList2->push(89);
    myList2->push(87);
    myList2->push(70);
    myList2->push(69);
    myList2->push(39);
    myList2->push(38);
    myList2->push(25);
    myList2->push(21);
    myList2->push(15);
    myList2->push(12);
    myList2->printList();



    /* PARTNER TASK */
   
    /* // TODO:  add delete method
    shared_ptr<Listy> mergedList = make_shared<Listy>();
    mergedList->merge(myList, myList2);
    mergedList->printList();
    */
     
}